From 597a829e0a42badc0eaba41597cf62681ba7ec62 Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Wed, 13 Sep 2017 19:29:45 -0700
Subject: [PATCH 8/8] WIP: Improve getBaseTypeAndTypemod() performance for
 builtin types.

Author: Robert Haas
Discussion: https://postgr.es/m/
---
 src/backend/utils/cache/lsyscache.c | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/src/backend/utils/cache/lsyscache.c b/src/backend/utils/cache/lsyscache.c
index b7a14dc87e..2a22da1489 100644
--- a/src/backend/utils/cache/lsyscache.c
+++ b/src/backend/utils/cache/lsyscache.c
@@ -2295,6 +2295,9 @@ getBaseTypeAndTypmod(Oid typid, int32 *typmod)
 		HeapTuple	tup;
 		Form_pg_type typTup;
 
+		if (typid < FirstBootstrapObjectId)
+			break;
+
 		tup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typid));
 		if (!HeapTupleIsValid(tup))
 			elog(ERROR, "cache lookup failed for type %u", typid);
-- 
2.14.1.536.g6867272d5b.dirty

